#include <config.h>
#include <windows.h>
#include <stdio.h>
#include <des.h>
#include <md5.h>
#include "m_md5.h"

static int init(EVP_MD_CTX *ctx)
{
	MD5_Init(ctx->md_data);
	return 0;
}

static int update(EVP_MD_CTX *ctx,const void *data,unsigned long count)
{
	MD5_Update(ctx->md_data,data,count);
	return 0;
}

static int final(EVP_MD_CTX *ctx,unsigned char *md)
{	
	MD5_Final(md,ctx->md_data);
	return 0;
}

static const EVP_MD md5_md=
	{
	MD5_DIGEST_LENGTH,
	init,
	update,
	final,
	sizeof(struct md5)
	};

const EVP_MD *
EVP_md5(void)
	{
	return(&md5_md);
	}

int
EVP_DigestInit(EVP_MD_CTX *ctx, const EVP_MD *type)
{
	ctx->digest = type;
	ctx->md_data = (void *)malloc(type->ctx_size);
	ctx->digest->init(ctx);
	return 0;
}

int
EVP_DigestUpdate(EVP_MD_CTX *ctx, const void *data,
		 unsigned int count)
{
	ctx->digest->update(ctx, data, count);
	return 0;
}

#pragma argsused
int
EVP_DigestFinal(EVP_MD_CTX *ctx, unsigned char *md, unsigned int *size)
{
	ctx->digest->final(ctx, md);
	free(ctx->md_data);
	ctx->md_data = 0;
	return 0;
}

int
RAND_bytes(char *dst, size_t siz)
{
	LARGE_INTEGER li;
        long rv;


	for (;siz >= sizeof(long); siz -= sizeof(long)) {
		QueryPerformanceCounter(&li);
		rv  = li.u.HighPart ^ li.u.LowPart;
		rv  ^= _lrand();
		*(long *)dst = rv;
		dst += sizeof(long);
		}

	for (;siz; siz--) {
		QueryPerformanceCounter(&li);
		rv  = li.u.HighPart ^ li.u.LowPart;
		rv  ^= _lrand();
		*dst++ = rv;
		}

	return 1;
}
