/*
 * Copyright (c) 1998 Thomas Nystrm and Stacken Computer Club
 * (Royal Institute of Technology, Stockholm, Sweden).
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the Kungliga Tekniska
 *      Hgskolan and its contributors.
 * 
 * 4. Neither the name of the Institute nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE INSTITUTE AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE INSTITUTE OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#define STRICT
#define _WXRTL_DLL
#include "wxrtl.h"
#pragma hdrstop

char *WErrors[] = {
"No Error",				//NO ERROR			0
"Invalid Function",			//ERROR INVALID FUNCTION	1
"File Not Found",			//ERROR FILE NOT FOUND		2
"Path Not Found",			//ERROR PATH NOT FOUND        	3
"Too Many Open Files",			//ERROR TOO MANY OPEN FILES   	4
"Access Denied",			//ERROR ACCESS DENIED     	5
"Invalid Handle",			//ERROR INVALID HANDLE        	6
"Arena Trashed",			//ERROR ARENA TRASHED     	7
"Not Enough Memory",			//ERROR NOT ENOUGH MEMORY     	8
"Invalid Block",			//ERROR INVALID BLOCK     	9
"Bad Environment",			//ERROR BAD ENVIRONMENT       	10
"Bad Format",				//ERROR BAD FORMAT        	11
"Invalid Access",			//ERROR INVALID ACCESS        	12
"Invalid Data",				//ERROR INVALID DATA      	13
0,					//				14
"Invalid Drive",			//ERROR INVALID DRIVE     	15
"Current Directory",			//ERROR CURRENT DIRECTORY     	16
"Not Same Device",			//ERROR NOT SAME DEVICE       	17
"No More Files",			//ERROR NO MORE FILES     	18
"Write Protect",			//ERROR WRITE PROTECT     	19
"Bad Unit",				//ERROR BAD UNIT          	20
"Not Ready",				//ERROR NOT READY         	21
"Bad Command",				//ERROR BAD COMMAND       	22
"Crc",					//ERROR CRC           		23
"Bad Length",				//ERROR BAD LENGTH        	24
"Seek",					//ERROR SEEK          		25
"Not Dos Disk",				//ERROR NOT DOS DISK      	26
"Sector Not Found",			//ERROR SECTOR NOT FOUND      	27
"Out Of Paper",				//ERROR OUT OF PAPER      	28
"Write Fault",				//ERROR WRITE FAULT       	29
"Read Fault",				//ERROR READ FAULT        	30
"Gen Failure",				//ERROR GEN FAILURE       	31
"Sharing Violation",			//ERROR SHARING VIOLATION	32
"Lock Violation",			//ERROR LOCK VIOLATION        	33
"Wrong Disk",				//ERROR WRONG DISK        	34
"Fcb Unavailable",			//ERROR FCB UNAVAILABLE       	35
"Sharing Buffer Exceeded",		//ERROR SHARING BUFFER EXCEEDED 36
0,					//				37
0,					//				38
0,					//				39
0,					//				40
0,					//				41
0,					//				42
0,					//				43
0,					//				44
0,					//				45
0,					//				46
0,					//				47
0,					//				48
0,					//				49
"Not Supported",			//ERROR NOT SUPPORTED     	50
0,					//				51
0,					//				52
0,					//				53
0,					//				54
0,					//				55
0,					//				56
0,					//				57
0,					//				58
0,					//				59
0,					//				60
0,					//				61
0,					//				62
0,					//				63
0,					//				64
0,					//				65
0,					//				66
0,					//				67
0,					//				68
0,					//				69
0,					//				70
0,					//				71
0,					//				72
0,					//				73
0,					//				74
0,					//				75
0,					//				76
0,					//				77
0,					//				78
0,					//				79
"File Exists",				//ERROR FILE EXISTS       	80
"Dup Fcb",				//ERROR DUP FCB           	81
"Cannot Make",				//ERROR CANNOT MAKE       	82
"Fail I24",				//ERROR FAIL I24          	83
"Out Of Structures",			//ERROR OUT OF STRUCTURES     	84
"Already Assigned",			//ERROR ALREADY ASSIGNED      	85
"Invalid Password",			//ERROR INVALID PASSWORD      	86
"Invalid Parameter",			//ERROR INVALID PARAMETER     	87
"Net Write Fault",			//ERROR NET WRITE FAULT       	88
"No Process Slots available",		//ERROR NO PROC SLOTS     	89
"Not Frozen",				//ERROR NOT FROZEN        	90
"Timer Service table ofl",		//ERR TSTOVFL         		91
"Timer Service duplicate",		//ERR TSTDUP			92
"No Items",				//ERROR NO ITEMS		93
0,					//				94
"Interrupted system call",		//ERROR INTERRUPT         	95
0,					//				96
0,					//				97
0,					//				98
0,					//				99
"Too Many Semaphores",			//ERROR TOO MANY SEMAPHORES   	100
"Excl Sem Already Owned",		//ERROR EXCL SEM ALREADY OWNED  101
"Sem Is Set",				//ERROR SEM IS SET        	102
"Too Many Sem Requests",		//ERROR TOO MANY SEM REQUESTS 	103
"Invalid At Interrupt Time",		//ERROR INVALID AT INTERRUPT TIME 104
"Semaphore Owner Died",			//ERROR SEM OWNER DIED        	105
"Semaphore User Limit",			//ERROR SEM USER LIMIT	        106
"Disk Change",				//ERROR DISK CHANGE		107
"Drive Locked",				//ERROR DRIVE LOCKED      	108
"Broken Pipe",				//ERROR BROKEN PIPE	       	109
"Open Failed",				//ERROR OPEN FAILED       	110
"Buffer Overflow",			//ERROR BUFFER OVERFLOW		111
"Disk Full",				//ERROR DISK FULL		112
"No More Search Handles",		//ERROR NO MORE SEARCH HANDLES  113
"Invalid Target Handle",		//ERROR INVALID TARGET HANDLE	114
"Protection Violation",			//ERROR PROTECTION VIOLATION	115
"Viokbd Request",			//ERROR VIOKBD REQUEST		116
"Invalid Category",			//ERROR INVALID CATEGORY	117
"Invalid Verify Switch",		//ERROR INVALID VERIFY SWITCH	118
"Bad Driver Level",			//ERROR BAD DRIVER LEVEL      	119
"Call Not Implemented",			//ERROR CALL NOT IMPLEMENTED  	120
"Semaphore Timeout",			//ERROR SEM TIMEOUT       	121
"Insufficient Buffer",			//ERROR INSUFFICIENT BUFFER   	122
"Invalid Name",				//ERROR INVALID NAME      	123
"Invalid Level",			//ERROR INVALID LEVEL     	124
"No Volume Label",			//ERROR NO VOLUME LABEL       	125
"Module Not Found",			//ERROR MOD NOT FOUND		126
"Process Not Found",			//ERROR PROC NOT FOUND        	127
"Wait No Children",			//ERROR WAIT NO CHILDREN      	128
"Child Not Complete",			//ERROR CHILD NOT COMPLETE    	129
"Direct Access Handle",			//ERROR DIRECT ACCESS HANDLE  	130
"Negative Seek",			//ERROR NEGATIVE SEEK     	131
"Seek On Device",			//ERROR SEEK ON DEVICE        	132
};

int WErrnum = sizeof(WErrors) / sizeof(char *);

char *WSAErrors1[] = {
0,					//				0
0,					//				1
0,					//				2
0,					//				3
"Interrupted system call",		//WSAEINTR			4
0,					//				5
0,					//				6
0,					//				7
0,					//				8
"Bad file descriptor",			//WSAEBADF			9
0,					//				10
0,					//				11
0,					//				12
"Permission denied",			//WSAEACCESS			13
"Bad address",				//WSAEFAULT			14
0,					//				15
0,					//				16
0,					//				17
0,					//				18
0,					//				19
0,					//				20
0,					//				21
"Invalid argument",			//WSAEINVAL			22
0,					//				23
"Too many open files",			//WSAEMFILE			24
0,					//				25
0,					//				26
0,					//				27
0,					//				28
0,					//				29
0,					//				30
0,					//				31
0,					//				32
0,					//				33
0,					//				34
"Operation would block",		//WSAEWOULDBLOCK		35
"Operation now in progress",		//WSAEINPROGRESS		36
"Operation already in progress",	//WSAEALREADY			37
"Socket operation on non-socket",	//WSAENOTSOCK			38
"Destination address required",		//WSAEDESTADDRREQ		39
"Message too long",			//WSAEMSGSIZE			40
"Protocol wrong type for socket",	//WSAEPROTOTYPE			41
"Protocol not available",		//WSAENOPROTOOPT		42
"Protocol not supported",		//WSAEPROTONOSUPPORT		43
"Socket type not supported",		//WSAESOCKTNOSUPPORT		44
"Operation not supported",		//WSAEOPNOTSUPP			45
"Protocol family not supported",	//WSAEPFNOSUPPORT		46
"Address not supported by protocol",	//WSAEAFNOSUPPORT		47
"Address already in use",		//WSAEADDRINUSE			48
"Can't assign requested address",	//WSAEADDRNOTAVAIL		49
"Network is down",			//WSAENETDOWN			50
"Network is unreachable",		//WSAENETUNREACH		51
"Network dropped connection on reset",	//WSAENETRESET			52
"Software caused connection abort",	//WSAECONNABORTED		53
"Connection reset by peer",		//WSAECONNRESET			54
"No buffer space available",		//WSAENOBUFS			55
"Socket is already connected",		//WSAEISCONN			56
"Socket is not connected",		//WSAENOTCONN			57
"Can't send after socket shutdown",	//WSAESHUTDOWN			58
"Too many references: can't splice",	//WSAETOOMANYREFS		59
"Operation timed out",			//WSAETIMEDOUT			60
"Connection refused",			//WSAECONNREFUSED		61
"Too many levels of symbolic links",	//WSAELOOP			62
"File name too long",			//WSAENAMETOOLONG		63
"Host is down",				//WSAEHOSTDOWN			64
"No route to host",			//WSAEHOSTUNREACH		65
"Directory not empty",			//WSAENOTEMPTY			66
"Too many processes",			//WSAEPROCLIM			67
"Too many users",			//WSAEUSERS			68
"Disc quota exceeded",			//WSAEDQUOT			69
"Stale NFS file handle",		//WSAESTALE			70
"Too many levels of remote in path",	//WSAEREMOTE			71
"RPC struct is bad",			//WSAEBADRPC			72
0,					//				73
0,					//				74
0,					//				75
0,					//				76
0,					//				77
0,					//				78
0,					//				79
0,					//				80
0,					//				81
0,					//				82
0,					//				83
0,					//				84
0,					//				85
0,					//				86
0,					//				87
0,					//				88
0,					//				89
0,					//				90
"System not ready",			//WSASYSNOTREADY		91
"Version not supported",		//WSAVERNOTSUPPORTED		92
"Not initialised",			//WSANOTINITIALISED		93
0,					//				94
0,					//				95
0,					//				96
0,					//				97
0,					//				98
0,					//				99
0,					//				100
"Disconnected",				//WSAEDISCON			101
};

int WSAErrnum1 = sizeof(WSAErrors1) / sizeof(char *);

char *WSAErrors2[] = {
0,					//				0
"Host not found",			//WSAHOST_NOT_FOUND		1
"Temporary server fail",		//WSATRY_AGAIN			2
"Permanent server fail",		//WSANO_RECOVERY		3
"No data returned",			//WSANO_DATA			4
};

int WSAErrnum2 = sizeof(WSAErrors2) / sizeof(char *);

#define CHECKERR(errcode, table, size, base) 				\
	if ((errcode >= base) && ((errcode - (base)) <= size)) {	\
		if (table[errcode-(base)]) 				\
			return table[errcode-(base)];			\
		}

const char * _WXRTLFUNC 
Wstrerror(int ErrCode)
{
	static char eb[128];

	CHECKERR(ErrCode, WErrors,	WErrnum,	0);
	CHECKERR(ErrCode, WSAErrors1,	WSAErrnum1,	WSABASEERR);
	CHECKERR(ErrCode, WSAErrors2,	WSAErrnum2,	WSABASEERR+1000);

	sprintf(eb, "Error 0x%08x", ErrCode);
	return eb;
}
